

Godet = {
	prerequisitesPresent = function (specializations)
		return true
	end
}

source("dataS/scripts/vehicles/specializations/SetTurnedOnEvent.lua");
source("dataS/scripts/vehicles/specializations/PloughAreaEvent.lua");

  
function Godet.prerequisitesPresent(specializations)
      return true;
end;

function Godet:load(xmlFile)

  		assert(self.setIsTurnedOn == nil, "Sprayer needs to be the first specialization which implements setIsTurnedOn");
        self.setIsTurnedOn = Godet.setIsTurnedOn;
        self.isTurnedOn = false;
		self.activation = false;

		self.terrassement = false;
        self.terrassementNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.terrassement#index"));

        self.terrassementNodeA = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.terrassementa#index"));
        self.terrassementNodeB = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.terrassementb#index"));
        self.terrassementNodeC = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.terrassementc#index"));
        self.terrassementNodeD = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.terrassementd#index"));
        self.terrassementNodeE = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.terrassemente#index"));
        self.terrassementNodeF = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.terrassementf#index"));
        self.terrassementNodeG = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.terrassementg#index"));
        self.terrassementNodeH = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.terrassementh#index"));
        self.terrassementNodeI = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.terrassementi#index"));
        self.terrassementNodeJ = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.terrassementj#index"));
        self.terrassementNodeK = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.terrassementk#index"));
        self.terrassementNodeL = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.terrassementl#index"));
        self.terrassementNodeM = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.terrassementm#index"));
        self.terrassementNodeN = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.terrassementn#index"));
        self.terrassementNodeO = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.terrassemento#index"));

        self.aiTerrainDetailChannel1 = g_currentMission.ploughChannel;
        self.aiTerrainDetailChannel2 = g_currentMission.sowingChannel;
    
        self.fillremplissage = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.fillremplissage"), 500);
        self.fillvidage = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.fillvidage"), 5);
        
        self.godet = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.godet#index"));

		self.terralargeur = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.terralargeur"), 500);
		self.terrahauteur = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.terrahauteur"), 500);
		
		self.tera1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.tera1#index"));
		self.tera2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.tera2#index"));
        
		self.playVidagegodet = SpecializationUtil.callSpecializationsFunction("playVidagegodet");
	
	   
	        self.sampleVidagegodet = Utils.loadSample(xmlFile, {}, "vehicle.VidagegodetSound", nil, self.baseDirectory, self.components[1].node);
			self.VidagegodetSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.VidagegodetSound#pitchOffset"), 0);
            self.VidagegodetSoundPitchScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.VidagegodetSound#pitchScale"), 0.05);
            self.VidagegodetSoundPitchMax = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.VidagegodetSound#pitchMax"), 2.0);
            self.VidagegodetSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.VidagegodetSound#volume"), 1.0);
	        self.samplecreuse = Utils.loadSample(xmlFile, {}, "vehicle.ploughSound", nil, self.baseDirectory);
			self.fred = 0;		
end;
  
function Godet:delete()
	if self.isClient then
	    Utils.deleteSample(self.sampleVidagegodet);
	end;
end;
   
   
function Godet:readStream(streamId, connection)
    local turnedOn = streamReadBool(streamId);
	self:setIsTurnedOn(turnedOn, true);
end;
 
function Godet:writeStream(streamId, connection)
	streamWriteBool(streamId, self.isTurnedOn);
end;
 
function Godet:mouseEvent(posX, posY, isDown, isUp, button)
end;
 
function Godet:keyEvent(unicode, sym, modifier, isDown)
end;
 
function Godet:update(dt)

if self.samplecreuse ~= nil then
	if self.sampleVidagegodet ~= nil then
		if self.camIndex ~= nil then
			if self.camIndex == 2 then
				Utils.setSampleVolume(self.sampleVidagegodet, 0.3);
				Utils.setSampleVolume(self.samplecreuse, 0.3);
			else
				Utils.setSampleVolume(self.sampleVidagegodet, 2);
				Utils.setSampleVolume(self.samplecreuse, 3);
			end;
		end;
	end;
end;

	local dx, dy, dz = localDirectionToWorld(self.terrassementNode, 0, 0, 1)
	local capa = self.fillLevel ;
	if self.fred == 2 and capa == 0 then
		self.fred = 0;
	end;
	
    if dy >= self.shovelEmptyStartCosAngle and capa > 1 then
		self.fred = 0;
	end;
   if self.shovelEmptySpeed ~= nil then
		if self.terrassementNode ~= nil then
			if self.fred == 0 then
				local dx, dy, dz = localDirectionToWorld(self.terrassementNode, 0, 0, 1)
				local capa = self.fillLevel ;
				if dy < self.shovelEmptyStartCosAngle and capa > 1 then
					if not Utils.isSamplePlaying(self.sampleVidagegodet, 5*dt) then
						self.fred = 1;	
					end;						
				end;

			end;
		end;
    end;
	if self.fred == 1 then
		if self:getIsActiveForSound() then
			if not self.terrassement then
				self.fred = 2
				self:playVidagegodet(true);
			end
		end
	else
		if not Utils.isSamplePlaying(self.sampleVidagegodet, 5*dt) then
			self:playVidagegodet(false);
		end
	 end

    if self.isClient then
        if self:getIsActiveForInput() then
            if InputBinding.hasEvent(InputBinding.Godet) then
                self:setIsTurnedOn(not self.isTurnedOn);
            end;
        end;
    end;
       
    if self.isTurnedOn then
		self.activation = true ;
	else	
		self.activation = false;
		 
	end;
end;
 
function Godet:updateTick(dt)

    if self:getIsActiveForInput() then
        if InputBinding.hasEvent(InputBinding.Godet) then
        	self.activation = not self.activation;
        end;
    end;

    local x,y,z = getWorldTranslation(self.terrassementNode);
    local terrainHeight = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x, 0, z);
		if y<= terrainHeight then
			self.terrassement = true;
		else
			self.terrassement = false;
			Utils.stopSample(self.samplecreuse);
		end;

    if self.terrassement then
		local xt,yt,zt = getRotation(self.tera1);
		if xt > 0 then
            if self.activation then
                if self.fillLevel ~= self.capacity then
                        local workAreasSend = {};
                        for k, workArea in pairs(self.workAreas) do
                            if self:getIsAreaActive(workArea) then
                                local x,y,z = getWorldTranslation(workArea.start);
                                local x1,y1,z1 = getWorldTranslation(workArea.width);
                                local x2,y2,z2 = getWorldTranslation(workArea.height);
                                --Utils.updatePloughArea(x, z, x1, z1, x2, z2, not self.PloughLimitToField);
                                table.insert(workAreasSend, {x,z,x1,z1,x2,z2});
                            end;
                        end;
                        if (table.getn(workAreasSend) > 0) then
                            local realArea = PloughAreaEvent.runLocally(workAreasSend, limitToField, limitGrassDestructionToField, angle);
                            local usage = self.fillremplissage * dt*0.001;
                            local usedFruitType = FruitUtil.FRUITTYPE_DIRT;
                            local usedFillType = FruitUtil.fruitTypeToFillType[usedFruitType];                                                                             
                            self:setFillLevel(self.fillLevel + usage, usedFillType);
							
								Utils.playSample(self.samplecreuse, 0, 0, nil);
						else
							Utils.stopSample(self.samplecreuse);
						end;
                end;
			end;
        end;
    end;        
end;
 
function Godet:draw()
    if self.activation then
		g_currentMission:addHelpButtonText(g_i18n:getText("TerrOff"), InputBinding.Godet);
	else
		g_currentMission:addHelpButtonText(g_i18n:getText("TerrOn"), InputBinding.Godet);
    end;   
end;
 
 Godet.loadFromAttributesAndNodes = function (self, xmlFile, key, resetVehicles)
	return BaseMission.VEHICLE_LOAD_OK
end
Godet.getSaveAttributesAndNodes = function (self, nodeIdent)
	local attributes = ""
	local nodes = ""
	return attributes, nodes
end

function Godet:onAttach(attacherVehicle)
end;
  
function Godet:onDetach()
end;

function Godet:onActivate()
end;
 
function Godet:onDeactivate()       
end;
 
function Godet:onDeactivateSounds()
	    Utils.stopSample(self.sampleVidagegodet, true);
	    Utils.stop3DSample(self.sampleVidagegodet);
end;
 
function Godet:aiRotateLeft()
end;
 
function Godet:aiRotateRight()
end;
 
function Godet:aiTurnOn()
end;
 
function Godet:aiTurnOff()
end;
 
function Godet:aiInvertsMarkerOnTurn(turnLeft)
end;
 
function Godet:setRotationMax(rotationMax, noEventSend)
end;

function Godet:setIsTurnedOn(isTurnedOn, noEventSend)
    SetTurnedOnEvent.sendEvent(self, isTurnedOn, noEventSend)
    self.isTurnedOn = isTurnedOn;
end;
   
function Godet:onDeactivate()
    self.isTurnedOn = false;
end;
   
function Godet:onLeave()
    self.isTurnedOn = false;
end;

function Godet:playVidagegodet(isPlaying, noEventSend)

		if self.sampleVidagegodet ~= nil then
			VidagegodetEvent.sendEvent(self, isPlaying, noEventSend);

	        if isPlaying then
	                Utils.playSample(self.sampleVidagegodet, 0, 0, nil);			
					local VidagegodetSoundPitch = math.min(self.VidagegodetSoundPitchOffset + self.VidagegodetSoundPitchScale*math.abs(1*4), self.VidagegodetSoundPitchMax)
					Utils.setSamplePitch(self.sampleVidagegodet, VidagegodetSoundPitch);
	
	                elseif self.blabla then
	                    -- enable 3d sound to vehicle on another player's game
	                    Utils.play3DSample(self.sampleVidagegodet);
						if self.sampleVidagegodet ~= nil then				
						local VidagegodetSoundPitch = math.min(self.VidagegodetSoundPitchOffset + self.VidagegodetSoundPitchScale*math.abs(1*4), self.VidagegodetSoundPitchMax)
						Utils.setSamplePitch(self.sampleVidagegodet, VidagegodetSoundPitch);
					end;
	        else
	            Godet.onDeactivateSounds(self);
	        end;
		end;
	end;
	
	VidagegodetEvent = {};
	VidagegodetEvent_mt = Class(VidagegodetEvent, Event);
	
	InitEventClass(VidagegodetEvent, "VidagegodetEvent");
	
	
	function VidagegodetEvent:emptyNew()
	
    local self = Event:new(VidagegodetEvent_mt);
	    return self;
	end;
	
	function VidagegodetEvent:new(object, isPlaying)
	
	    local self = VidagegodetEvent:emptyNew()
	    self.object = object;
		self.isPlaying = isPlaying;
	    return self;
	end;
	
	function VidagegodetEvent:readStream(streamId, connection)
	
	    local id = streamReadInt32(streamId);
		self.isPlaying = streamReadBool(streamId);
	    self.object = networkGetObject(id);
	    self:run(connection);
	end;
	
	function VidagegodetEvent:writeStream(streamId, connection)
	
	    streamWriteInt32(streamId, networkGetObjectId(self.object));
		streamWriteBool(streamId, self.isPlaying);
	end;
	
	function VidagegodetEvent:run(connection)
	
	    self.object:playVidagegodet(self.isPlaying, true);
		
	    if not connection:getIsServer() then
	        g_server:broadcastEvent(VidagegodetEvent:new(self.object, self.isPlaying), nil, connection, self.object);
	    end;
	end;
	
	function VidagegodetEvent.sendEvent(vehicle, isPlaying, noEventSend)
	
	    if isPlaying ~= vehicle.honkPlaying then
	        if noEventSend == nil or noEventSend == false then
	            if g_server ~= nil then
	                g_server:broadcastEvent(VidagegodetEvent:new(vehicle, isPlaying), nil, nil, vehicle);
	            else
	                g_client:getServerConnection():sendEvent(VidagegodetEvent:new(vehicle, isPlaying));
	            end;
	        end;
	    end;
	end;	 



